SPDX-License-Identifier: CC-BY-SA-4.0 OR BSD-2-Clause
brief: |
  Returns the buffer to the partition.
copyrights:
- Copyright (C) 2020 embedded brains GmbH (http://www.embedded-brains.de)
- Copyright (C) 1988, 2008 On-Line Applications Research Corporation (OAR)
definition:
  default:
    attributes: null
    body: null
    params:
    - ${../../type/if/id:/name} ${.:/params[0]/name}
    - void *${.:/params[1]/name}
    return: ${../../status/if/code:/name}
  variants: []
description: |
  This directive returns the buffer specified by ${.:/params[1]/name} to the
  partition specified by ${.:/params[0]/name}.
enabled-by: true
index-entries:
- return buffer to partition
interface-type: function
links:
- role: interface-placement
  uid: header
- role: interface-ingroup
  uid: group
name: rtems_partition_return_buffer
notes: |
  This directive will not cause the running task to be preempted.

  Returning a buffer to a global partition which does not reside on the local
  node will generate a request telling the remote node to return the buffer to
  the partition.

  Returning a buffer multiple times is an error.  It will corrupt the internal
  state of the partition.
params:
- description: is the partition identifier.
  dir: null
  name: id
- description: is the pointer to the buffer to return.
  dir: null
  name: buffer
return:
  return: null
  return-values:
  - description: |
      The requested operation was successful.
    value: ${../../status/if/successful:/name}
  - description: |
      There was no partition with the specified identifier.
    value: ${../../status/if/invalid-id:/name}
  - description: |
      The buffer referenced by ${.:/params[1]/name} was not in the
      partition.
    value: ${../../status/if/invalid-address:/name}
type: interface
